<?php

/*
 * @author TargetBay
 * @copyright 2016 Sathishkumar Mariappan <sathishkumar.m@innoppl.com>
 * @package Targetbay_Tracking
 */

class Targetbay_Tracking_Block_Product_Richsnippets extends Mage_Core_Block_Template
{
    /**
     * Rendered the tracking review template if tracking enabled
     *
     * @see Mage_Core_Block_Template::_construct()
     */
    public function _construct()
    {
        parent::_construct();
        if ((int) Mage::helper('tracking')->getRichSnippetType()) {
            $this->setTemplate('tracking/product/richsnippets.phtml');
        }
    }

    /**
     * Get the current product
     * @return Mage_Catalog_Model_Product
     */
    public function getProduct()
    {
        return Mage::registry('current_product');
    }

    /**
     * @return mixed
     */
    public function getEscapedProductName()
    {
        return $this->escapeHtml($this->getProduct()->getName());
    }

    /**
     * @return string
     */
    public function getEscapedDescription()
    {
        $product = $this->getProduct();

        if (!$product) {
            return '';
        }

        $string = $product->getDescription();

        return strip_tags(html_entity_decode($string));
    }

    /**
     * @return string
     */
    public function getSku()
    {
        $product = $this->getProduct();

        if (!$product) {
            return '';
        }

        return $product->getSku();
    }

    /**
     * @return string
     */
    public function getImageUrl()
    {
        $product = $this->getProduct();

        if (!$product) {
            return '';
        }

        return  Mage::helper('catalog/image')->init($product, 'image');
    }
}
