<?php

/*
 * @author Targetbay
 * @copyright 2016 Sathishkumar Mariappan <sathishkumar.m@innoppl.com>
 * @package Targetbay_Tracking
 */

class Targetbay_Tracking_Block_Recommended extends Mage_Core_Block_Template
{

    /**
     * Rendered the tracking template if tracking enabled
     *
     * @see Mage_Core_Block_Template::_construct()
     */
    public function _construct()
    {
        parent::_construct();
        if (Mage::helper('tracking')->trackingEnabled() &&
            Mage::helper('tracking')->getRecommendationStatus()) {
            $this->setTemplate('tracking/recommended.phtml');
        }
        $this->storeId = Mage::app()->getStore()->getId();
    }

    /**
     * @return string
     */
    public function tbPlaceholder()
    {
        $controllerName = Mage::app()->getRequest()->getControllerName();
        $moduleName = Mage::app()->getRequest()->getModuleName();
        $actionName = Mage::app()->getRequest()->getActionName();
        $homeTagName = trim(Mage::getStoreConfig(
            'targetbay_tracking/tracking_product_recommendation/homepage',
             $this->storeId
        ));
        $categoryTagName = trim(Mage::getStoreConfig(
            'targetbay_tracking/tracking_product_recommendation/category_page',
            $this->storeId
        ));
        $productTagName = trim(Mage::getStoreConfig(
            'targetbay_tracking/tracking_product_recommendation/product_page',
            $this->storeId
        ));
        $cartTagName = trim(Mage::getStoreConfig(
            'targetbay_tracking/tracking_product_recommendation/shopping_cart',
            $this->storeId
        ));
        $successTagName = trim(Mage::getStoreConfig(
            'targetbay_tracking/tracking_product_recommendation/success',
            $this->storeId
        ));
        $searchTagName = trim(Mage::getStoreConfig(
            'targetbay_tracking/tracking_product_recommendation/catalogsearch',
            $this->storeId
        ));
        $errorTagName = trim(Mage::getStoreConfig(
            'targetbay_tracking/tracking_product_recommendation/noroute',
            $this->storeId
        ));
        $html = '';

        switch ($controllerName) {
            case 'category':
                if (!empty($categoryTagName)) {
                    $html .= '<div class="tb_recommend tb_recommend_category" data-tb="' . $categoryTagName . '"></div>';
                }
            break;

            case 'product':
                if (!empty($productTagName)) {
                    $html .= '<div class="tb_recommend tb_recommend_product" data-tb="' . $productTagName . '"></div>';
                }
            break;

            case 'cart':
                if (!empty($cartTagName)) {
                    $html .= '<div class="tb_recommend tb_recommend_shopping" data-tb="' . $cartTagName . '"></div>';
                }
            break;

            case 'result':
                if ($moduleName === 'catalogsearch' && !empty($searchTagName)) {
                    $html .= '<div class="tb_recommend tb_recommend_search" data-tb="' . $searchTagName . '"></div>';
                }
            break;

            case 'index':
                if ($moduleName === 'cms' && $actionName === 'noRoute' && !empty($errorTagName)) {
                    $html .= '<div class="tb_recommend tb_recommend_404page" data-tb="' . $errorTagName . '"></div>';
                }
                if (Mage::getBlockSingleton('page/html_header')->getIsHomePage() && !empty($homeTagName)) {
                    $html .= '<div class="tb_recommend tb_recommend_front" data-tb="' . $homeTagName . '"></div>';
                }
            break;

            case 'onepage':
                if ($actionName === 'success' && !empty($successTagName)) {
                    $html .= '<div class="tb_recommend tb_recommend_thankyoupage" data-tb="' . $successTagName . '"></div>';
                }
            break;

            default:
            break;
        }

        return $html;
    }
}
