<?php

/*
 * @author Targetbay
 * @copyright 2016 Sathishkumar Mariappan <sathishkumar.m@innoppl.com>
 * @package Targetbay_Tracking
 */

class Targetbay_Tracking_Model_Api2_Review_Rest_Guest_V1 extends Mage_Api2_Model_Resource
{

    /**
     * Retrieve review
     *
     * @return array
     */
    protected function _retrieveCollection()
    {
        $page_num = Mage::app()->getRequest()->getParam('page');
        $limit = Mage::app()->getRequest()->getParam('limit');
        $store_id = Mage::app()->getRequest()->getParam('website_id');

        $reviewCollection = Mage::getModel('review/review')->getResourceCollection()
        	->addStoreFilter($store_id)
            ->setPageSize($limit)
            ->setCurPage($page_num)
            ->setDateOrder()
            ->addRateVotes()
            ->load();

        $reviewData = array();
        $reviewResult = array();
        //$sku = '';
        foreach ($reviewCollection as $review) {
            // $storeId = Mage::getModel('review/review')->load($review->getId())->getStoreId();
            $product = Mage::getModel('catalog/product')->load($review->getEntityPkValue());
            $sku = $product->getSku();

            if ($sku) {
                $ratingCollection = Mage::getModel('rating/rating_option_vote')
                    ->getResourceCollection()
                    ->setReviewFilter($review->getId());

                //$rating_val = "";
                //$option = "";
                $optionValue = '';
                foreach ($ratingCollection as $rating) {
                    $option = $rating->getOptionId();
                    $rating_val = $rating->getRatingId();

                    if (!empty($optionValue) && $optionValue !== '') {
                        $optionValue = $optionValue . '@' . $rating_val . ':' . $option;
                    } else {
                        $optionValue = $rating_val . ':' . $option;
                    }
                }
                $reviewData['entity_id'] = $review->getId();
                $reviewData['product_id'] = $review->getEntityPkValue();
                $reviewData['sku'] = $sku;
                $reviewData['title'] = $review->getTitle();
                $reviewData['detail'] = $review->getDetail();
                $reviewData['nickname'] = $review->getNickname();
                $reviewData['store_id'] = $store_id;
                $reviewData['website_id'] = Mage::getModel('core/store')->load($store_id)->getWebsiteId();
                $reviewData['customer_id'] = $review->getCustomer_id();
                $reviewData['option_id'] = $optionValue;
                $reviewData['created_at'] = Mage::helper('core')->formatDate($review->getCreated_at(), 'long');
                $reviewData['status_id'] = $review->getStatus_id();
                $reviewResult[$review->getId()][] = $reviewData;
            }
        }

        return $reviewResult;
    }
}
