<?php
/*
 * @author TargetBay
 * @copyright 2016 Sathishkumar Mariappan <sathishkumar.m@innoppl.com>
 * @package Targetbay_Tracking
 */
class Targetbay_Tracking_Model_Api2_Tbreviewcount_Rest_Guest_V1 extends Targetbay_Tracking_Model_Api2_Tbreviewcount
{

    /**
     * Get the Review count from TargetBay
     *
     * @return array
     */
    public function _retrieveCollection()
    {
        $pageReference = Mage::app()->getRequest()->getParam('page_identifier') ? Mage::app()->getRequest()->getParam('page_identifier') : '';

        $reviewCount = Mage::app()->getRequest()->getParam('review_count') ? Mage::app()->getRequest()->getParam('review_count') : '';

        $product = Mage::app()->getRequest()->getParam('product_id') ? Mage::app()->getRequest()->getParam('product_id') : '';
        $prodcutExplode = explode('?', $product);
        $productId = $prodcutExplode[0];

        $categoryId = Mage::app()->getRequest()->getParam('category_id') ? Mage::app()->getRequest()->getParam('category_id') : '';
        $cachesiteTbCountId = 'site_tbreview_count';
        $cacheTbCountId = 'product_tbreview_count';
        $cacheqTbCountId = 'qa_tbreview_count';

        if (!empty($pageReference) && $reviewCount !== '') {
            try {
                switch ($pageReference) {
                    case Targetbay_Tracking_Helper_Data::RATINGS_STATS:
                    if ($reviewCount == 'comment') {
                        if ($productId == '' || $productId == 0) {
                            Mage::app()->getCache()->remove($cachesiteTbCountId);
                            Mage::app()->getCache()->save(serialize($reviewCount), $cacheSiteTbCountId);
                        } elseif ($productId !== '' || $productId > 0) {
                            $cacheDataId = $cacheTbCountId . '_' . $productId;
                            Mage::app()->getCache()->remove($cacheDataId);
                            Mage::app()->getCache()->save(serialize($reviewCount), $cacheDataId);
                        }
                    } else {
                        if ($productId == '' || $productId == 0) {
                            Mage::app()->getCache()->remove($cachesiteTbCountId);
                            Mage::app()->getCache()->save(serialize($reviewCount), $cachesiteTbCountId);
                        } elseif ($productId !== '' || $productId > 0) {
                            $cacheDataId = $cacheTbCountId . '_' . $productId;
                            Mage::app()->getCache()->remove($cacheDataId);
                            Mage::app()->getCache()->save(serialize($reviewCount), $cacheDataId);
                        }
                    }
                    break;
                    case Targetbay_Tracking_Helper_Data::QUESTION_STATS:
                        if ((string) $reviewCount) {
                            $cacheDataId = $cacheqTbCountId . '_' . $productId;
                            Mage::app()->getCache()->remove($cacheDataId);
                            Mage::app()->getCache()->save(serialize($reviewCount), $cacheDataId);
                        } else {
                            $cacheDataId = $cacheqTbCountId . '_' . $productId;
                            Mage::app()->getCache()->save(serialize($reviewCount), $cacheDataId);
                            Mage::app()->getCache()->save(serialize($reviewCount), $cacheDataId);
                        }
                    break;
                }
            } catch (\Exception $e) {
                Mage::helper('tracking')->debug($e->getMessage());
            }

            // Clear the particular product cache while review,question post,comment,delete
            // Amasty cache
            if (Mage::helper('core')->isModuleEnabled('Amasty_Fpc')) {
                  $tags = array();
                  $tags[]= 'catalog_product_'.$productId;
                  $fpc = Mage::getSingleton('amfpc/fpc');
                  $fpc->clean($tags);  
            }

            // Clear the particular product cache while review,question post,comment,delete
            // lesti FPC 
            if (Mage::helper('core')->isModuleEnabled('Lesti_Fpc')) { 
                    $productId = "product_".$productId;
                    $cacheId = sha1($productId);
                    $fpc = Mage::getModel('fpc/fpc');
                    $fpc->clean($cacheId);
            }

            // Clear the particular product cache while review,question post,comment,delete
            // Bolt FPC
            if (Mage::helper('core')->isModuleEnabled('Fishpig_Bolt')) {
                    $product = Mage::getModel('catalog/product')->load($productId);
                    $boltHelper = Mage::helper('bolt/cache')->refreshProduct($product, false);
            }
        }
    }
}
