<?php
/**
 * @author Targetbay
 * @copyright 2016 Sathishkumar Mariappan <sathishkumar.m@innoppl.com>
 * @package Targetbay_Tracking
 */
class Targetbay_Tracking_Model_Log extends Mage_Core_Model_Abstract
{
    /**
     * Initializes the object
     *
     * @return void
     */
    public function _construct()
    {
        parent::_construct();
        $this->_init('tracking/log');
    }

    /**
     * Process a cart modified data
     */
    public function saveCartData()
    {
        try {
            /* @var Targetbay_Tracking_Helper_Data $helper */
            $helper = Mage::helper('tracking');
            $trackingSesssionId = Mage::helper('tracking')->getFetchPointsByKey('_utid');

            if ($helper->trackingEnabled() && $trackingSesssionId > 0) {
                $trackingSesssionId = Mage::helper('tracking')->getFetchPointsByKey('_utid');
                $quoteId = Mage::getSingleton('checkout/session')->getQuoteId();
                $storeId = Mage::app()->getStore()->getId();
                $websiteId = Mage::app()->getStore()->getWebsiteId();

                /* @var Targetbay_Tracking_Model_Log $updateModel */
                $updateModel = Mage::getModel('tracking/log');
                $updateModel->load($trackingSesssionId, 'tracking_id');

                if (!$updateModel->getData()) {
                    $updateModel->setTrackingId($trackingSesssionId)
                    ->setTrackingId($trackingSesssionId)
                    ->setStoreId($storeId)
                    ->setWebsiteId($websiteId)
                    ->setQuoteId($quoteId)
                    ->setUpdatedAt(gmdate('Y-m-d'))
                    ->setStatus(true)
                    ->save();
                }else{
                    $updateModel->setQuoteId($quoteId)->save();
                }

            }
        } catch (Exception $e) {
            $helper->debug('ERROR: ' . $e->getMessage());
        }

        return $this;
    }

   /**
     * Process a cart modified data
     */
    public function removeCartData()
    {
        $helper = Mage::helper('tracking');
        $trackingSesssionId =  (int) $helper->getFetchPointsByKey('_utid');

        // $trackingSessionId = Mage::helper('tracking')->cookie->get('trackingid');
        $quoteId = Mage::getSingleton('checkout/session')->getQuoteId();
        $model = Mage::getModel('tracking/log');
        $model->load($trackingSesssionId, 'tracking_id');
        try {
            if ($model->getId()) {
                // Delete the entry from targetbay_tracking_log.
                $model->delete();
            }
        } catch (Exception $e) {
            $helper->debug('ERROR: ' . $e->getMessage());
        }

        return $this;
    }
}
