<?php

/*
 * @author Targetbay
 * @copyright 2016 Sathishkumar Mariappan <sathishkumar.m@innoppl.com>
 * @package Targetbay_Tracking
 */

class Targetbay_Tracking_Model_Reviewfeed extends Mage_Customer_Model_Customer
{
    const TBREVEW_FEED = 'tb-review-feed';

    /**
     * Real file path
     *
     * @var string
     */
    protected $_filePath;

    /**
     * @return bool|void
     */
    public function tbReviewFeed()
    {
        $helper = Mage::helper('tracking');
        if (!$helper->getGoogleQuestionReviewSnippet()) {
            return false;
        }

        /*
        $type = self::TBREVEW_FEED;
        $websiteId = Mage::app()->getStore()->getWebsiteId();
        $cacheResponseId = 'tbreview_feed_response';
        $apiToken = '?api_token=' . $helper->getApiToken($websiteId);
        $feedUrl = $helper->getHostname() . $type . $apiToken;
        $data['index_name'] = $helper->getApiIndex($websiteId);
        */

        $data = array();
        $cacheResponseId = 'tbreview_feed_response';
        $feedUrl = $helper->getHost(self::TBREVEW_FEED, Mage::app()->getStore()->getWebsiteId());

        try {
            $cache = Mage::app()->getCache();
            if ($reviewFeed = $cache->load($cacheResponseId)) {
                $cache->remove($reviewFeed);
            }

            $jsonData = json_encode($data);
            $response = $helper->postPageInfo($feedUrl, $jsonData);
            $responseBody = json_decode($response);
            $reviewFeed = $responseBody->reviewFeed;
            $cache->save(serialize($reviewFeed), $cacheResponseId);

            return $reviewFeed;
        } catch (Exception $e) {
            $helper->debug('Error message ' . $e->getMessage());
            return;
        }
    }

    /**
     *
     */
    public function tbReviewFeedStatic()
    {
        $helper = Mage::helper('tracking');

        /*
        $type = self::TBREVEW_FEED;
        $websiteId = Mage::app()->getStore()->getWebsiteId();
        $apiToken = '?api_token=' . $helper->getApiToken($websiteId);
        $feedUrl = $helper->getHostname() . $type . $apiToken;
        $data['index_name'] = $helper->getApiIndex($websiteId);
        */

        $data = array();
        $feedUrl = $helper->getHost(self::TBREVEW_FEED, Mage::app()->getStore()->getWebsiteId());

        try {
            $jsonData = json_encode($data);
            $response = $helper->postPageInfo($feedUrl, $jsonData);
            $responseBody = json_decode($response);

            return $responseBody->reviewFeed;
        } catch (Exception $e) {
            $helper->debug('Error message ' . $e->getMessage());
            return;
        }
    }

    /**
     * Generate XML file
     *
     * @return void|bool
     */
    public function generateXml()
    {
        $helper = Mage::helper('tracking');
        if (!$helper->getGoogleQuestionReviewSnippet()) {
            return false;
        }

        $io = new Varien_Io_File();
        $io->setAllowCreateFolders(true);
        $io->open(array('path' => $this->getPath()));

        $fileName = 'google-product-review-feed.xml';

        if ($io->fileExists($fileName) && !$io->isWriteable($fileName)) {
            Mage::throwException(Mage::helper('tracking')->__('File "%s" cannot be saved. Please, make sure the directory "%s" is writable by web server.', $fileName, $this->getPath()));
        }

        $io->streamOpen($fileName);
        $io->streamWrite('');
        $io->streamOpen($fileName);

        $cacheResponseId = 'tbreview_feed_response';
        if ($reviewFeed = Mage::app()->getCache()->load($cacheResponseId)) {
            $reviewFeed = unserialize($reviewFeed);
        } else {
            $reviewFeed = $this->tbReviewFeedStatic();
        }

        $io->streamWrite(str_replace('&', '&amp;', $reviewFeed));
        $io->streamClose();
    }

    /**
     * Return real file path
     *
     * @return string
     */
    protected function getPath()
    {
        if (null === $this->_filePath) {
            $this->_filePath = Mage::getBaseDir() . '/';
        }

        return $this->_filePath;
    }
}
