<?php
/**
 * @author Targetbay
 * @copyright 2016 Sathishkumar Mariappan <sathishkumar.m@innoppl.com>
 * @package Targetbay_Tracking
 */
$installer = $this;
$installer->startSetup();
$adapter = $installer->getConnection();

$installer->run(
    "
DROP TABLE IF EXISTS {$installer->getTable('tracking/log')};
CREATE TABLE IF NOT EXISTS {$installer->getTable('tracking/log')} (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `tracking_id` int(10),
  `store_id` int(11) DEFAULT NULL,
  `website_id` int(11) DEFAULT NULL,
  `quote_id` int(11) DEFAULT NULL,
  `date_entered` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `status` tinyint(4) NOT NULL,
  PRIMARY KEY (`tracking_id`),
  KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
"
);

// Add admin notification if no TargetBay api key or secret is inserted yet.

$shouldShowNotification = false;

foreach (Mage::app()->getStores() as $store) {
    if (!Mage::getStoreConfig('targetbay_tracking/tracking_groups/api_token', $store) || !Mage::getStoreConfig('targetbay_tracking/tracking_groups/api_index', $store)) {
        $shouldShowNotification = true;
        break;
    }
}

if ($shouldShowNotification) {
    Mage::helper('tracking/Utils')->createAdminNotification
    (
        'Please visit the TargetBay extension page in your system configuration store settings page and finish the installation.',
        'In order to start generating reviews with TargetBay, you\'ll need to finish the installation process',
        'http://targetbay.com/configuring-targetbay-after-installation?utm_source=customers_magento_admin&utm_medium=pop_up&utm_campaign=magento_not_installed_pop_up'
    );
}

$installer->endSetup();
